#

API Docs for:
Show: Inherited Protected Private Deprecated

# Plots Class

Defined in: `input/charts/Plots.js:1`
Module: charts

Utility class used for drawing markers.

- Index
- Methods
- Properties

## Item Index

### Methods

- _clearMarkerCache
- _createGroupMarkers
- _createMarker
- _createMarkerCache
- _getGroupShape
- _getItemColor
- _getPlotDefaults
- _getState
- _parseMarkerStyles
- _setStyles
- _toggleVisible
- drawPlots
- getMarker
- updateMarkerState

### Properties

- _groupShapes
- _markerCache
- _markers
- _plotDefaults
- _statSyles

## Methods

### `_clearMarkerCache`

() private

Defined in `input/charts/Plots.js:366`

Removes unused markers from the marker cache

### `_createGroupMarkers`

(

- `styles`

)
protected

Defined in `input/charts/Plots.js:286`

Draws a series of markers in a single shape instance.

#### Parameters:

- `styles` Object

  Set of configuration properties used to create the markers.

### `_createMarker`

(

- `styles`
- `order`
- `index`

)
private

Defined in `input/charts/Plots.js:240`

Creates a shape to be used as a marker.

#### Parameters:

- `styles` Object

  Hash of style properties.

- `order` Number

  Order of the series.

- `index` Number

  Index within the series associated with the marker.

#### Returns:

Shape

### `_createMarkerCache`

() private

Defined in `input/charts/Plots.js:262`

Creates a cache of markers for reuse.

### `_getGroupShape`

(

- `shape`

)
protected

Defined in `input/charts/Plots.js:132`

Returns the correct group shape class.

#### Parameters:

- `shape` Shape | String

  Indicates which shape class.

#### Returns:

Function

### `_getItemColor`

(

- `val`
- `i`

)
protected

Defined in `input/charts/Plots.js:417`

Parses a color from an array.

#### Parameters:

- `val` Array

  collection of colors

- `i` Number

  index of the item

#### Returns:

String

### `_getPlotDefaults`

() protected

Defined in `input/charts/Plots.js:149`

Gets the default values for series that use the utility. This method is used by the class' `styles` attribute's getter to get build default values.

#### Returns:

Object

### `_getState`

(

- `type`

)
protected

Defined in `input/charts/Plots.js:475`

Returns marker state based on event type

#### Parameters:

- `type` String

  event type

#### Returns:

String

### `_parseMarkerStyles`

(

- `Object`

)
private

Defined in `input/charts/Plots.js:449`

Combines new styles with existing styles.

#### Parameters:

- `Object` Object

  containing style properties for the marker.

#### Returns:

Object

### `_setStyles`

(

- `newStyles`

)
protected

Defined in `input/charts/Plots.js:435`

Method used by `styles` setter. Overrides base implementation.

#### Parameters:

- `newStyles` Object

  Hash of properties to update.

#### Returns:

Object

### `_toggleVisible`

(

- `visible`

)
private

Defined in `input/charts/Plots.js:339`

Toggles visibility

#### Parameters:

- `visible` Boolean

  indicates visibilitye

### `drawPlots`

() protected

Defined in `input/charts/Plots.js:31`

Draws the markers

### `getMarker`

(

- `styles`
- `order`
- `index`

)
protected

Defined in `input/charts/Plots.js:198`

Gets and styles a marker. If there is a marker in cache, it will use it. Otherwise it will create one.

#### Parameters:

- `styles` Object

  Hash of style properties.

- `order` Number

  Order of the series.

- `index` Number

  Index within the series associated with the marker.

#### Returns:

Shape

### `updateMarkerState`

(

- `type`
- `i`

)
protected

Defined in `input/charts/Plots.js:385`

Resizes and positions markers based on a mouse interaction.

#### Parameters:

- `type` String

  state of the marker

- `i` Number

  index of the marker

## Properties

### `_groupShapes`

Unknown private

Defined in `input/charts/Plots.js:119`

Pre-defined group shapes.

### `_markerCache`

Array private

Defined in `input/charts/Plots.js:189`

Collection of markers to be re-used on a series redraw.

### `_markers`

Array private

Defined in `input/charts/Plots.js:180`

Collection of markers to be used in the series.

### `_plotDefaults`

Object private

Defined in `input/charts/Plots.js:22`

Storage for default marker styles.

### `_statSyles`

Object private

Defined in `input/charts/Plots.js:504`